unit Controle_BLDC;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Thales, Instrund, StdCtrls, ThlMisc2, Instrect, Potis, ComPorts, Tasten,
  Thalmisc, ExtCtrls, Menus, ThalBits, DXClass;

type
  TForm1 = class(TForm)
    ComPortT1: TComPortT;
    GroupBox3: TGroupBox;
    I_Phase_A: TMeter120;
    RotLabel3: TRotLabel;
    I_Phase_B: TMeter120;
    RotLabel2: TRotLabel;
    I_Phase_C: TMeter120;
    RotLabel4: TRotLabel;
    GroupBox4: TGroupBox;
    Label1: TLabel;
    Indice_mod: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    Frequence: TMemo;
    Label4: TLabel;
    Inc_Phase: TMemo;
    Batt_I: TMeterPanelV;
    Batt_V: TMeterPanelV;
    Label6: TLabel;
    Temp_Batt: TMemo;
    Vitesse: TMeter270;
    RotLabel1: TRotLabel;
    GroupBox5: TGroupBox;
    Consigne_T: TPotiSlide;
    Consigne_V: TPotiSlide;
    LedButton_T: TLedButton;
    Consigne_C: TPotiSlide;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LedButton_V: TLedButton;
    LedButton_C: TLedButton;
    Avance_Phase: TSlider;
    RotLabel5: TRotLabel;
    Label9: TLabel;
    Temp_Mot: TMemo;
    StaticText1: TStaticText;
    GroupBox1: TGroupBox;
    Label10: TLabel;
    Diam_roue: TNumEdit;
    Label11: TLabel;
    Label12: TLabel;
    Correcteur_P: TNumEdit;
    Label13: TLabel;
    Correcteur_I: TNumEdit;
    Correcteur_D: TNumEdit;
    Label14: TLabel;
    Phase_Rotor: TMeter360;
    MainMenu1: TMainMenu;
    PortCOM1: TMenuItem;
    COM11: TMenuItem;
    COM21: TMenuItem;
    ThProcPriority1: TThProcPriority;
    DXTimer1: TDXTimer;
    Buf_RXD_gauge: TGaugeGp;
    Label15: TLabel;
    Offset_angle: TMemo;
    Com_ON_OFF: TLedButton;
    procedure FormCreate(Sender: TObject);
    procedure COM11Click(Sender: TObject);
    procedure COM21Click(Sender: TObject);
    procedure DXTimer1Timer(Sender: TObject; LagCount: Integer);
    procedure Avance_PhaseChanging(Sender: TObject);
    procedure Avance_PhaseChanged(Sender: TObject);
    procedure LedButton_TDown(Sender: TObject);
    procedure LedButton_TUp(Sender: TObject);
    procedure LedButton_VClick(Sender: TObject);
    procedure LedButton_VUp(Sender: TObject);
    procedure LedButton_CClick(Sender: TObject);
    procedure LedButton_CUp(Sender: TObject);
    procedure Consigne_TChanging(Sender: TObject);
    procedure Com_ON_OFFDown(Sender: TObject);
    procedure Com_ON_OFFUp(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

const
  Fcy = 16000000;

var
  Form1: TForm1;
  Mag_angle_Stator: real; // Phase actuelle du stator: 0  360
  // Buffer de rception des donnes
  // Format : $AA,x,Dh;Dl,$AA : x = code de la donne
  //                            Dh = octet MSB donne
  //                            Dl = octet MSB donne
  Buffer_RX_data: array[0..4] of byte;
  Consigne: char; //'P': poigne, 'T':tension, 'V':vitesse, 'C':couple
  Communication : boolean;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var i: integer;
begin
 for i:=0 to 4 do Buffer_RX_data[i]:=0;
 Mag_angle_Stator:=0;
end;

procedure TForm1.COM11Click(Sender: TObject);
begin
 if COM21.Checked then exit;
 if COM11.Checked
  then
   begin
    ComPortT1.CloseComPort;
    COM11.Checked:=false;
    Com_ON_OFF.Down:=false;
    Com_ON_OFF.LedOn:=false;
    Communication:=false;
   end
  else
   begin
    ComPortT1.ComName:='Com1';
    if (ComPortT1.OpenComPort<>0) then COM11.Checked:=false
                                  else COM11.Checked:=true;
   end;
end;

procedure TForm1.COM21Click(Sender: TObject);
begin
 if COM11.Checked then exit;
 if COM21.Checked
  then
   begin
    ComPortT1.CloseComPort;
    COM21.Checked:=false;
    Com_ON_OFF.Down:=false;
    Com_ON_OFF.LedOn:=false;
    Communication:=false;
   end
  else
   begin
    ComPortT1.ComName:='Com2';
    if (ComPortT1.OpenComPort<>0) then COM21.Checked:=false
                                  else COM21.Checked:=true;
   end;
end;

procedure TForm1.DXTimer1Timer(Sender: TObject; LagCount: Integer);
var t : boolean;
    c : char;
    i : integer;
    s : string;
begin
 if ComPortT1.ReceiveChr(c) then
  begin
   Buf_RXD_Gauge.Value:=ComPortT1.ReceiveStat;
   for i:=1 to 4 do Buffer_RX_data[i-1]:=Buffer_RX_data[i];
   Buffer_RX_data[4]:=byte(c);
   if (Buffer_RX_data[0]=$AA) and (Buffer_RX_data[4]=$AA)
    then
     begin
      case Buffer_RX_data[1] of
       byte('S') : // Angle magntique stator
         begin
          Mag_angle_Stator:=(Buffer_RX_data[2]*256+Buffer_RX_data[3])*360/(6*256);
          Phase_Rotor.Value1:=Mag_angle_Stator;
          Phase_Rotor.Value2:=Mag_angle_Stator+Avance_Phase.Value;
         end;
       byte('P') : // Priode d'un secteur
         begin
          Vitesse.Value:=(Diam_roue.ValueFloat/100)*PI*3.6
            *(Fcy/256)/((Buffer_RX_data[2]*256+Buffer_RX_data[3])*6*20);
          Str((Fcy/256)/((Buffer_RX_data[2]*256+Buffer_RX_data[3])*6):3:1,s);
          Frequence.Lines.Text:=s+ 'Hz';
         end;
       byte('I') : // Indice de modulation
         begin
          Str(Buffer_RX_data[2]*256+Buffer_RX_data[3],s); s:=s+'%';
          Indice_mod.Lines.Text:=s;
         end;
       byte('A') : // Incrment de phase
         begin
          Str((Buffer_RX_data[2]*256+Buffer_RX_data[3])*360/(6*256*8192):2:2,s); s:=s+'';
          Inc_Phase.Lines.Text:=s;
         end;
       byte('B') : // Offset angle
         begin
          if Buffer_RX_data[2]<128
            then i:=Buffer_RX_data[2]*256+Buffer_RX_data[3]
            else i:=-65536+Buffer_RX_data[2]*256+Buffer_RX_data[3];
          Str(i*360/(6*131072):2:1,s);
          Offset_angle.Lines.Text:=s+'';
         end;
       byte('O') : // PDC_min
         begin
          Batt_V.Value:=Buffer_RX_data[2]*256+Buffer_RX_data[3];
         end;
       byte('Q') : // PDC_max
         begin
          Batt_I.Value:=Buffer_RX_data[2]*256+Buffer_RX_data[3];
         end;
       end;
     end;
  end;
end;

procedure TForm1.Avance_PhaseChanging(Sender: TObject);
var s : string;
begin
 Phase_Rotor.Value2:=Mag_angle_Stator+Avance_Phase.Value;
end;

procedure TForm1.Avance_PhaseChanged(Sender: TObject);
var Offset_angle : integer; // Angle  multiplier par 16
begin
 Offset_angle:=round(Avance_Phase.Value*6*2097152/(360*16));
 ComPortT1.TransmChr(char($AA));
 ComPortT1.TransmChr('B');
 ComPortT1.TransmChr(char(hi(Offset_angle)));
 ComPortT1.TransmChr(char(lo(Offset_angle)));
 ComPortT1.TransmChr(char($AA));
end;

procedure Transmit_type_consigne;
begin
 Form1.ComPortT1.TransmChr(char($AA));
 Form1.ComPortT1.TransmChr('C');
 Form1.ComPortT1.TransmChr(Consigne);
 Form1.ComPortT1.TransmChr(' ');
 Form1.ComPortT1.TransmChr(char($AA));
end;

procedure TForm1.LedButton_TDown(Sender: TObject);
begin
 LedButton_V.LedOn:=false; LedButton_V.Down:=false;
 LedButton_C.LedOn:=false; LedButton_C.Down:=false;
 LedButton_T.LedOn:=true;
 Consigne:='T';
 Transmit_type_consigne;
 Consigne_T.Value:=0;
 ComPortT1.TransmChr(char($AA));
 ComPortT1.TransmChr('T');
 ComPortT1.TransmChr(char(0));
 ComPortT1.TransmChr(char(0));
 ComPortT1.TransmChr(char($AA));
end;

procedure TForm1.LedButton_TUp(Sender: TObject);
begin
 LedButton_V.LedOn:=false; LedButton_V.Down:=false;
 LedButton_C.LedOn:=false; LedButton_C.Down:=false;
 LedButton_T.LedOn:=false;
 Consigne:='P'; //Poigne
 Transmit_type_consigne;
end;

procedure TForm1.LedButton_VClick(Sender: TObject);
begin
 LedButton_T.LedOn:=false; LedButton_T.Down:=false;
 LedButton_C.LedOn:=false; LedButton_C.Down:=false;
 LedButton_V.LedOn:=true;
 Consigne:='V'; //Vitesse
 Transmit_type_consigne;
end;

procedure TForm1.LedButton_VUp(Sender: TObject);
begin
 LedButton_T.LedOn:=false; LedButton_T.Down:=false;
 LedButton_C.LedOn:=false; LedButton_C.Down:=false;
 LedButton_V.LedOn:=false;
 Consigne:='P'; //Poigne
 Transmit_type_consigne;
end;

procedure TForm1.LedButton_CClick(Sender: TObject);
begin
 LedButton_V.LedOn:=false; LedButton_V.Down:=false;
 LedButton_T.LedOn:=false; LedButton_T.Down:=false;
 LedButton_C.LedOn:=true;
 Consigne:='C'; //Couple
 Transmit_type_consigne;
end;

procedure TForm1.LedButton_CUp(Sender: TObject);
begin
 LedButton_V.LedOn:=false; LedButton_V.Down:=false;
 LedButton_T.LedOn:=false; LedButton_T.Down:=false;
 LedButton_C.LedOn:=true;
 Consigne:='P'; //Poigne
 Transmit_type_consigne;
end;

procedure TForm1.Consigne_TChanging(Sender: TObject);
var Tension : integer;
begin
 if Consigne <> 'T' then exit;
 Tension:=round(Consigne_T.Value*1023/Consigne_T.ValueEnd);
 ComPortT1.TransmChr(char($AA));
 ComPortT1.TransmChr('T');
 ComPortT1.TransmChr(char(hi(Tension)));
 ComPortT1.TransmChr(char(lo(Tension)));
 ComPortT1.TransmChr(char($AA));
end;

procedure TForm1.Com_ON_OFFDown(Sender: TObject);
begin
 if COM11.Checked or COM21.Checked
  then
   begin
    Com_ON_OFF.LedOn:=true;
    Communication:=true;
    ComPortT1.TransmChr(char($AA));
    ComPortT1.TransmChr('P');
    ComPortT1.TransmChr(char(1));
    ComPortT1.TransmChr(char(1));
    ComPortT1.TransmChr(char($AA));
   end
  else
   begin
    Com_ON_OFF.LedOn:=false;
    Communication:=false;
    Com_ON_OFF.Down:=false;
   end
end;

procedure TForm1.Com_ON_OFFUp(Sender: TObject);
begin
 ComPortT1.TransmChr(char($AA));
 ComPortT1.TransmChr('P');
 ComPortT1.TransmChr(char(0));
 ComPortT1.TransmChr(char(0));
 ComPortT1.TransmChr(char($AA));
 Com_ON_OFF.LedOn:=false;
 Communication:=false;
 Consigne:='P';
 LedButton_T.Down:=false; LedButton_T.LedOn:=false;
 LedButton_V.Down:=false; LedButton_V.LedOn:=false;
 LedButton_C.Down:=false; LedButton_C.LedOn:=false;
 Consigne_T.Value:=0; Consigne_V.Value:=0; Consigne_C.Value:=0;
end;

end.
